<?php

/**
 * agrup_concep_tot_detalle actions.
 *
 * @package    nomina
 * @subpackage agrup_concep_tot_detalle
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class agrup_concep_tot_detalleActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by ID_TIPO_DOC , NUM_DOC, codigo ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $id_periodo = $periodo_filtro;
            $periodo = $request['id_periodo'];
            $id_agrup_concepto = $request['id_agrup_concepto'];


            /**
             * Se agrega fecha para calculo de dias y periodos del tipo valor V - 20151105
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            $fecha_ini = explode('-', $fecha_ini);
            $fecha_fin = explode('-', $fecha_fin);

            $anho_ini = $fecha_ini[0];
            $mes_ini = $fecha_ini[1];
            $anho_fin = $fecha_ini[0];
            $mes_fin = $fecha_fin[1];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //area
            if (isset($request['id_ea'])) {
                $whereArea = " AND tab0.id_ea = " . $request['id_ea'];
            } else {
                $whereArea = ' ';
            }
            //cenop
            if (isset($request['id_cen_op'])) {
                $whereCenOp = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOp = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

    select tab0.* from (

        select 
        tab0.id_estado_func,
        tab0.id_tipo_doc,
        tab0.num_doc,
        tab0.id_dp,
        tab0.id_anhos,
        tab0.id_meses,
        tab0.periodo,
        tab0.actual,
        tab0.id_ea,
        tab0.id_cen_op,
        tab0.rn,
        agr.id_concep_nomina,
        agr.tipo_valor,
        cons.nombre as nombre_valor,
        (select no_concep_nomina.codigo from no_concep_nomina where no_concep_nomina.id_concep_nomina = agr.id_concep_nomina) as codigo,
        (select no_concep_nomina.descripcion from no_concep_nomina where no_concep_nomina.id_concep_nomina = agr.id_concep_nomina) as descripcion,
        nvl(no_consulta_sql_f($anho_ini,$mes_ini,$anho_fin,$mes_fin,tab0.id_tipo_doc,tab0.num_doc,agr.id_concep_nomina,agr.tipo_valor,tab0.periodo) ,0) as valor
        from no_estado_func_v tab0
        left join no_agrup_deta agr on agr.id_agrup_concepto = $id_agrup_concepto
        left join no_consulta cons on to_char(cons.caracter) = to_char(agr.tipo_valor)

        where 
        tab0.periodo = $periodo_filtro 
        $whereFuncionarioNumDoc
        $whereFuncionarioTipoDoc
        $whereArea $whereCenOp

    )tab0
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (


select tab0.* from (

    select 
    tab0.id_estado_func,
    tab0.id_tipo_doc,
    tab0.num_doc,
    tab0.id_dp,
    tab0.id_anhos,
    tab0.id_meses,
    tab0.periodo,
    tab0.actual,
    tab0.id_ea,
    tab0.id_cen_op,
    tab0.rn,
    agr.id_concep_nomina,
    agr.tipo_valor,
        cons.nombre as nombre_valor,
    (select no_concep_nomina.codigo from no_concep_nomina where no_concep_nomina.id_concep_nomina = agr.id_concep_nomina) as codigo,
    (select no_concep_nomina.descripcion from no_concep_nomina where no_concep_nomina.id_concep_nomina = agr.id_concep_nomina) as descripcion,
    nvl(no_consulta_sql_f($anho_ini,$mes_ini,$anho_fin,$mes_fin,tab0.id_tipo_doc,tab0.num_doc,agr.id_concep_nomina,agr.tipo_valor,tab0.periodo) ,0) as valor
    from no_estado_func_v tab0
    left join no_agrup_deta agr on agr.id_agrup_concepto = $id_agrup_concepto
    left join no_consulta cons on to_char(cons.caracter) = to_char(agr.tipo_valor)
    
    where 
    tab0.periodo = $periodo_filtro 
    $whereFuncionarioNumDoc
    $whereFuncionarioTipoDoc
    $whereArea $whereCenOp

)tab0

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[agrup_concep_tot_detalle] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
